#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<signal.h>
#include	<time.h>
#include	<netdb.h>
#include	<signal.h>
#include	<termios.h>
#include	<unistd.h>
#include	<fcntl.h>
#include	<sys/time.h>
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>
#include	<utmp.h>

#ifdef	__linux__
#include	<linux/time.h>
#include	<linux/socket.h>
#include	<linux/in.h>
#endif

#include	"voice.h"
#include	"voice_std.h"
#include	"voice_tcp.h"
#include	"voice.conf"
#ifdef AUTO_KANJI
 #include "kanjilib.h"
#endif

PUBLIC	int		socket_fd;
PUBLIC	int		width;
PRIVATE	char	Client_ID[255];
PRIVATE	char	handle[LENGTH*2];
PRIVATE	char	idname[9];
PRIVATE	char	c_addr[4];
PRIVATE	char	notice_msg[LENGTH*2];
PRIVATE	char	bulletin_msg[LENGTH*2];
PRIVATE	char	logfile[] = "/voicerec.log";
PRIVATE	char	record_dir[255];
PRIVATE	char	send_buffer[BUFFERLEN];
PRIVATE	char	recv_buffer[BUFFERLEN];
PRIVATE	char	title[LENGTH*2];
PRIVATE	u_char color_flag = ON;
PRIVATE	int		ack_num = 0;
PRIVATE	int		myslot;
PRIVATE	int		flag, log_flag, sp_flag, backlog_flag = OFF, color_code = C_INIT;
PRIVATE int		echo_flag;
PRIVATE	struct sockaddr_in	server;
PRIVATE	struct termios			termio_back;
PRIVATE struct termios			termio_int_back;
PRIVATE	struct hostent			*myhost;
PRIVATE	fd_set	mask;
PRIVATE	FILE		*flog;
PRIVATE	int	shutdown_count;
PRIVATE char	centering[5];
PRIVATE char	flushleft[5];
PRIVATE int		keep_counter;
PRIVATE int	intr_ignore;
PRIVATE int	intr_connect;
PRIVATE int	cl_address;
#ifdef AUTO_KANJI
PRIVATE	int kanji_code = SJIS;
#endif

int		setup_client(char*, int);
int		login(void);
int		command_ana(char*);
int		enter_room(int);
int		command_ar(int);
int		client_write(int, char*, int);
int		client_read(int, char*, int);
void	term_setup(void);
void	exit_room(void);
void	look_all(void);
void	look_room(int);
void	silent_handle(void);
void	change_handle(void);
void	change_title(void);
void	record(int);
void	color_control(int);
void	color_set(void);
void	echo_control(int);
void	door(int);
void	room_telegram(void);
void	reset_server(void);
void	version(void);
void	r_last(void);
void	not_superviser(void);
void	super_look(void);
void	super_exit(int);
void	super_kill(void);
void	super_close(void);
void	change_mode(int);
void	set_notice(void);
void	look_notice(void);
void	print_com_help(void);
void	init_session(void);
void	init_path(void);
void	menu_session(void);
void	command_menu(int);
void	main_session(void);
void	key_break(int);
void	print_board(void);
void	req_roomlog(void);
void	print_help(void);
void	alarm_sig(int);
void	perform(void);
void	look_bulletin(void);
void	set_bulletin(void);
void	intr_control(int);

#ifdef AUTO_KANJI
void	trans_kanjicode(char *);
#endif

int setup_client(char *hostname, int port)
{
	struct hostent *serverhost;
	char	myhostname[30];
/* my host information */
	gethostname(myhostname, 30);
	myhost = gethostbyname(myhostname);
	lbcopy((char*)myhost->h_addr, (char*)c_addr, 4);
	shutdown_count = 0;


/* server connexion */
	lbzero((char*)&server, sizeof(server));
	server.sin_family = AF_INET;
	server.sin_port = htons( port );
	if( ( serverhost=gethostbyname( hostname ) )!=NULL )
	{
		lbcopy((char*)serverhost->h_addr, (char*)&server.sin_addr, 
			serverhost->h_length);
	} 
	else if( ( server.sin_addr.s_addr=inet_addr( hostname ))==0 )
	{
		fprintf(stderr, "bad hostname  [%s].\n", hostname);
		fprintf(stderr, "usage : voice {option} hostname  \n");
		print_help();
		return(-1);
	}

	printf("opening connexion.........\n");
	if((socket_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		fprintf(stderr, "socket allocation failed.\n");
		return (-1);
	}

	if(connect(socket_fd, (struct sockaddr*)&server, sizeof(server)) == -1)
	{
		fprintf(stderr, "cannot connect voice server --- %s.\n", hostname);
		fprintf(stderr, " please send mail to cerbe@yamato.cc.kogakuin.ac.jp.\n");
		return (-1);
	}

	printf("complete connexion.\n");
	return	login();
}

void print_board(void)
{
	printf("# ----- Information. -----------------------\n");
	printf("#  New server started!\n");
	printf("#  Please check web in HTTP://voice.musication.to/\n");

	printf("#\n");
}

int login(void)
{
	struct utmp ut;
	struct utmp *u;

	send_buffer[0] = VERSION_C;
	send_buffer[1] = REVISION;
	send_buffer[2] = color_flag;
	send_buffer[3] = color_code;
	client_write(socket_fd, send_buffer, 4);
	client_read(socket_fd, recv_buffer, 4);
	if(recv_buffer[0] == REFUSE)
	{
		fprintf(stderr, "sorry. No match REVISION number. \n");
		fprintf(stderr, " server = %d , client = %d , server receive = %d \n",
			(int)recv_buffer[1], REVISION, (int)recv_buffer[2]);
		fprintf(stderr, "please send mail to cerbe@yamato.cc.kogakuin.ac.jp.\n");
		exit(255);
	}

	send_buffer[0] = CL_ADDRESS;
	send_buffer[1] = cl_address;
	if(cl_address == OFF)
	{
		send_buffer[2] = 0;
	}
	else
	{
		setutent();
		strcpy(ut.ut_line, ttyname(0)+strlen("/dev/"));
		u = getutline(&ut);
		strcpy(send_buffer+2, u->ut_host);
	}
	client_write(socket_fd, send_buffer, strlen(send_buffer+2)+3);

	strcpy(send_buffer+1, idname);
	send_buffer[0] = MESSAGE;
	client_write(socket_fd, send_buffer, strlen(send_buffer+1)+2);

	client_read(socket_fd, recv_buffer, 3);
	if(recv_buffer[0] == CANNOT_LOGIN)
	{
		fprintf(stderr, "sorry. cannot login.\n");
		fprintf(stderr, "now... Max user.\n");
		return(-1);
	}
	else if(recv_buffer[0] == LOGIN_OK)
	{
		client_write(socket_fd, handle, strlen(handle)+1);
		myslot = (int)recv_buffer[1];
		sscanf(recv_buffer+1, "%02d", &myslot);

		printf("# ===== Real Time Chat   VOICE Rev 1.1  pl %2d =====\n", PATCHLEVEL);
		printf("# ==  Welcome  to  VOICE,  %-20s  ==\n", handle);
		printf("# ==    Your slot number is %2d.                  ==\n", myslot);
		printf("# ==  Type \'?\' for information.                  ==\n");
		printf("# =================================================\n");
		print_board();
		return (1);
	}
	else 
		printf("recv_buffer[0] == %d\n", recv_buffer[0]);
		return (-2);
}

void logout(void)
{
	signal(SIGINT, SIG_IGN);
	send_buffer[0] = LOGOUT;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
	printf("Wait, Refreshing Port........\n");
	tcp_read(socket_fd, send_buffer, 2);
	printf("Bye.......connexion closed.\n");
	close(socket_fd);
}

void init_path(void)
{
	char	*p;

	log_flag = OFF;
	if((p = getenv("VOICE_RECORD_DIR")) == NULL)
		p = getenv("HOME");
	strcpy(record_dir, p);
	strcat(record_dir, logfile);
}

void init_session(void)
{
	struct	itimerval		rttimer;
	struct	itimerval		old_rttimer;

	keep_counter = 0;
	rttimer.it_value.tv_sec     = 60;
	rttimer.it_value.tv_usec    = 0;
	rttimer.it_interval.tv_sec  = 60;
	rttimer.it_interval.tv_usec = 0;
	setitimer(ITIMER_REAL, &rttimer, &old_rttimer);

	width = socket_fd + 1;
	FD_ZERO(&mask);
	FD_SET(0, &mask);
	FD_SET(socket_fd, &mask);
	flag = FREE;
	echo_flag = ON;
	sp_flag = NORMAL;
	tcgetattr(0, &termio_back);
	tcgetattr(0, &termio_int_back);

	strcpy(centering, "^");
	strcpy(flushleft, "");


	signal(SIGHUP, key_break);
	signal(SIGINT, key_break);
	signal(SIGABRT, key_break);
	signal(SIGTERM, key_break);
	signal(SIGQUIT, SIG_IGN);
	signal(SIGALRM, alarm_sig);
}

void alarm_sig(int signo)
{
	keep_counter++;

	/* measire disconnect 1min */
	if(intr_connect == ON)
	{
		putchar(' ');
		putchar(0x08);

		fflush(stdout);
	}

	if(keep_counter > C_MAX_KEEPALIVE)
	{
		printf("# No Responce from server.\n");
		key_break(SIGALRM);
		exit(0);
	}
	signal(SIGALRM, alarm_sig);
}


int command_ana(char *command)
{
	char	*second;

	second = seperate_par(command);
	strlower(command);
	if(!strcmp(command, "enter"))
	{
		if(second)
		{
			if(!strcmp(second, "1")) return (OP_ENTER_1);
			if(!strcmp(second, "2")) return (OP_ENTER_2);
			if(!strcmp(second, "3")) return (OP_ENTER_3);
			if(!strcmp(second, "4")) return (OP_ENTER_4);
			if(!strcmp(second, "5")) return (OP_ENTER_5);
			if(!strcmp(second, "6")) return (OP_ENTER_6);
		}
		printf("room number is 1~%d.\n", MAX_ROOM);
		return (OP_ILLI);
	} 
	else if(!strcmp(command, "look"))
	{
		if(second)
		{
			if(!strcmp(second, "all")) return (OP_LOOK_A);
			if(!strcmp(second, "1"))	 return (OP_LOOK_1);
			if(!strcmp(second, "2"))	 return	(OP_LOOK_2);
			if(!strcmp(second, "3"))	 return (OP_LOOK_3);
			if(!strcmp(second, "4"))   return (OP_LOOK_4);
			if(!strcmp(second, "5"))   return (OP_LOOK_5);
			if(!strcmp(second, "6"))   return (OP_LOOK_6);
		}
		if(!second)                return (OP_LOOK_D);
		printf("room number is 1~%d.\n", MAX_ROOM);
		return (OP_ILLI);
	} 
	else if(!strcmp(command, "notice"))
	{
		if(!second)								 return (OP_L_NOTICE);
		strncpy(notice_msg, second, LENGTH);
		return (OP_S_NOTICE);
	}
	else if(!strcmp(command, "bulletin"))
	{
		if(!second)									return (OP_L_BULLETIN);
		strncpy(bulletin_msg, second, BULLTNLEN);
		return (OP_S_BULLETIN);
	}	
	else if(!strcmp(command, "record"))
	{
		if(second)
		{
			if(!strcmp(second, "on")) 	return (OP_REC_ON);
			if(!strcmp(second, "off"))	return (OP_REC_OFF);
		}
		if(log_flag == OFF) printf("now ... record off\n");
		if(log_flag == ON ) printf("now ... record on\n");
		return (OP_ILLI);
	} 
	else if(!strcmp(command, "color") || !strcmp(command, "colour"))
	{
		if(second)
		{
			if(!strcmp(second, "on"))			return (OP_COLOR_ON);
			if(!strcmp(second, "off"))		return (OP_COLOR_OFF);
			     if(!strcmp(second,"black")  || !strcmp(second, "0")) color_code = C_BLACK;
			else if(!strcmp(second,"blue")   || !strcmp(second, "1")) color_code = C_BLUE;
			else if(!strcmp(second,"red")    || !strcmp(second, "2")) color_code = C_RED;
			else if(!strcmp(second,"magenta")|| !strcmp(second, "3")) color_code = C_MAGENTA;
			else if(!strcmp(second,"green")  || !strcmp(second, "4")) color_code = C_GREEN;
			else if(!strcmp(second,"cyan")   || !strcmp(second, "5")) color_code = C_CYAN;
			else if(!strcmp(second,"yellow") || !strcmp(second, "6")) color_code = C_YELLOW;
			else if(!strcmp(second,"white")  || !strcmp(second, "7")) color_code = C_WHITE;
			else if(!strcmp(second, "init")  || !strcmp(second, "8")) color_code = C_INIT;
			else return (OP_ILLI);
			printf("#Set colour code = %d\n", color_code);
			return (OP_COLOR_SET);
		}
		if(color_flag == OFF) printf("#now ... color off.\n");
		if(color_flag == ON ) printf("#now ... color on, color is %d\n", color_code);		
		return (OP_ILLI);
	}
	else if(!strcmp(command, "door"))
	{
		if(!second) return(OP_ILLI);
		if(!strcmp(second, "open"))		return (OP_DOOR_OPEN);
		if(!strcmp(second, "close"))	return (OP_DOOR_CLOSE);
		if(!strcmp(second, "lock"))		return (OP_DOOR_LOCK);
		return (OP_ILLI);
	}
	else if(!strcmp(command, "handle"))
	{
		if(second)
			strncpy(handle, second, LENGTH-2);
		printf("handle changed --- %s\n",handle);
		return(OP_HANDLE);
	}
	else if(!strcmp(command, "title"))
	{
		if(second)
			strncpy(title, second, LENGTH);
		return(OP_TITLE);
	}
	else if(!strcmp(command, "echo"))
	{
		if(!second) return(OP_ILLI);
		if(!strcmp(second, "on"))			return (OP_ECHO_ON);
		if(!strcmp(second, "off"))		return (OP_ECHO_OFF);
		return(OP_ILLI);
	}
	else if(!strcmp(command, "last"))
	{
		if(second) send_buffer[2] = (char)atoi(second);
		else 			 send_buffer[2] = 6;
		return(OP_LAST);
	}
#ifdef AUTO_KANJI
	else if(!strcmp(command, "kanji"))
	{
		if(second)
		{
			strlower(second);
			    if(!strcmp(second, "sjis"))
			{
				kanji_code = SJIS;
				printf("# Kanji code changed SHIFT JIS.\n");
			}
			else if(!strcmp(second, "jis"))
			{
				kanji_code = JIS;
				printf("# Kanji code changed JIS.\n");
			}
			else if(!strcmp(second, "euc"))
			{
				kanji_code = EUC;
				printf("# Kanji code Changed EUC.\n");
			}
			else return (OP_ILLI);
			silent_handle();
		}
		else
		{
			switch(kanji_code)
			{
				case SJIS:
					printf("# Now Kanji code is SHIFT JIS.\n");
					break;
				case JIS:
					printf("# Now Kanji code is JIS.\n");
					break;
				case EUC:
					printf("# Now Kanji code is EUC.\n");
					break;
			}
		}
		return OP_KANJI;
	}
	else if(!strcmp(command, "sjis"))
	{
		kanji_code = SJIS;
		silent_handle();
		printf("# Kanji code changed SJIS.\n");
		return OP_KANJI;
	}
	else if(!strcmp(command, "jis"))
	{
		kanji_code = JIS;
		silent_handle();
		printf("# Kanji code changed JIS.\n");
		return OP_KANJI;
	}
	else if(!strcmp(command, "euc"))
	{
		kanji_code = EUC;
		silent_handle();
		printf("# Kanji code changed EUC.\n");
		return OP_KANJI;
	}
#endif  
	else if(!strcmp(command, "perf"))		return(OP_PERFORM);
	else if(!strcmp(command, "open"))		return(OP_DOOR_OPEN);
	else if(!strcmp(command, "close"))	return(OP_DOOR_CLOSE);
	else if(!strcmp(command, "lock"))		return(OP_DOOR_LOCK);
	else if(!strcmp(command, "!"))			return(OP_RT);
	else if(!strcmp(command, "ver"))		return(OP_VER);
	else if(!strcmp(command, "nlook"))	return(OP_NLOOK);
	else if(!strcmp(command, "superviser"))		return(OP_SUPER);
	else if(!strcmp(command, "normaluser"))		return(OP_NORMAL);
	else if(!strcmp(command, "slook"))	return(OP_SLOOK);
	else if(!strcmp(command, "sclose"))	return(OP_SCLOSE);
	else if(!strcmp(command, "sexit"))	return(OP_SEXIT);
	else if(!strcmp(command, "skill"))	return(OP_SKILL);
	else if(!strcmp(command, "shung"))	return(OP_SHUNG);
	else if(!strcmp(command, "reset_server")) return(OP_RESET);
	else if(!strcmp(command, "help")) 	return(OP_HELP);
	else if(!strcmp(command, "?"))    	return(OP_HELP);
	else if(!strcmp(command, "exit")) 	return(OP_EXIT);
	else if(!strcmp(command, "quit")) 	return(OP_EXIT);
	else return (OP_ILLI);	
}

int	command_ar(int msg_flag)
{
	if(flag > MAX_ROOM)
	{
		if(msg_flag != OFF)
			printf("# This command cannot use outside room.\n");
		return(REFUSE);
	}
	return(ACCEPT);
}
	
void req_roomlog(void)
{
	printf("#This room\'s back log.....\n");
	send_buffer[0] = R_LOG;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
	burst_read(socket_fd, recv_buffer, "");
}


int enter_room(int room)
{
	int		i;

	send_buffer[0] = room;	
	send_buffer[1] = myslot;
	send_buffer[2] = backlog_flag;	
	client_write(socket_fd, send_buffer, 3);
	i = client_read(socket_fd, recv_buffer, BUFFERLEN);
	recv_buffer[i] = 0;
	if(recv_buffer[0] == ENTER_OK)
	{
		printf("Entering Room %d. Please enjoy.\n", room);
		echo_control(ON);
		flag = room;
		if(backlog_flag == ON) req_roomlog();
		return(ENTER_OK);
	}
	printf("%s", recv_buffer+1);
	return(CANNOT_ENTER);
}

void exit_room(void)
{
	printf("Exit Room. Thank you.\n");
	send_buffer[0] = EXIT;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
	flag = FREE;
	echo_control(ON);
}

void door(int door_status)
{
	send_buffer[0] = DOOR;
	send_buffer[1] = door_status;
	send_buffer[2] = myslot;
	client_write(socket_fd, send_buffer, 3);

	if(door_status == OPEN)		printf("# This door was opened\n");
	if(door_status == CLOSE) 	printf("# This door was closed\n");
	if(door_status == LOCK) 	printf("# This door was locked\n");
}	

void room_telegram()
{
	int		s_number;	
	char		work[BUFFERLEN];

	printf("# TELEGRAM IN ROOM\n");
	printf("# (SLOT) ROOM  HANDLE                [     ID]\n"); 
	send_buffer[0] = REQ_ALL;
	send_buffer[1] = 0;
	client_write(socket_fd, send_buffer, 2);
	burst_read(socket_fd, recv_buffer, " ");

	printf("# Input slot number -> ");
	scanf("%d", &s_number);
	printf("# Input send message-> ");
	scanf("%s", work);
	strcpy(send_buffer+3, work);
	send_buffer[0] = ROOM_TELE;
	send_buffer[1] = myslot;
	send_buffer[2] = s_number;
	client_write(socket_fd, send_buffer, strlen(work)+4);
	client_read(socket_fd, recv_buffer, 10);
	if(recv_buffer[0] == ACCEPT)
		printf("# Telegram sent.\n");
	else if(recv_buffer[0] == REFUSE)
		printf("# Invalid slot numbfer. Telegram cound not send.\n");
}



void reset_server(void)
{
	char	work[50];

	printf("     ----------  WARNING  ----------     \n");
	printf("  This command \'RESET_SERVER\' reset server.\n");
	printf("  Sure? (yes/else)  ... input full spell.>>");
	scanf("%s", work);
	if(strcmp(work, "yes")) return;

	send_buffer[0] = RESET;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
	printf("  Reset.........bye.\n");
	exit(1);
}

void change_mode(int mode)
{
	char	pw[50];

	printf("password>>");
	noecho_scanf("%s", pw);
	fflush(stdin);
	send_buffer[0] = (char)mode;
	send_buffer[1] = myslot;
	strcpy(send_buffer+2, pw);
	client_write(socket_fd, send_buffer, strlen(pw)+3);
	client_read(socket_fd, recv_buffer, BUFFERLEN);
	if(recv_buffer[0] == ACCEPT)
	{
		if(mode == SUPERVISE)
		{
			printf("\n# Now...your mode is superviser.\n");
			sp_flag = SUPERVISE;
		}
		if(mode == NORMAL)
		{
			printf("\n# Now...your mode is normal user.\n");
			sp_flag = NORMAL;
		}
	}
	else if(recv_buffer[0] == REFUSE)
		printf("\n# Cannot accept your request.\n");
}

void super_look(void)
{
	int		i;

	printf("#SUPER LOOK\n");
	send_buffer[0] = SLOOK;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
	for(;;)
	{
		i = client_read(socket_fd, recv_buffer, BUFFERLEN);
		recv_buffer[i] = 0;
		if(recv_buffer[0] == REFUSE)
		{
			not_superviser();
			break;
		}
		else if(recv_buffer[0] == ENDOFDATA) return;
		printf("%s\n", recv_buffer+1);
	}
}

void super_close(void)
{
	int		f, i;

	printf("file descripter>>");
	scanf("%d", &f);
	send_buffer[0] = SCLOSE;
	send_buffer[1] = myslot;
	send_buffer[2] = f;
	client_write(socket_fd, send_buffer, 3);
	i = client_read(socket_fd, recv_buffer, BUFFERLEN);
	if(recv_buffer[0] == REFUSE)	not_superviser();
}
		


void super_exit(int mode)
{
	int		i;
	char	work[50];

	printf("#SUPER EXIT!\n");
	printf("     ----------  WARNING  ----------     \n");
	printf("  This command \'super exit\' exit server process.\n");
	printf("  Sure? (yes/else)  ... input full spell.>>");
	scanf("%s", work);
	fflush(stdin);
	if(strcmp(work, "yes")) return;

	send_buffer[0] = mode;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);

	i = client_read(socket_fd, recv_buffer, BUFFERLEN);
	recv_buffer[i] = 0;
	if(recv_buffer[0] == REFUSE)
	{
		not_superviser();
		return;
	}
	exit(1);
}	

void super_kill(void)
{
	int		i, slot;

	printf("# SUPER KILL!! Input kill user number -> ");
	scanf("%d", &slot);
	send_buffer[0] = SKILL;
	send_buffer[1] = myslot;
	send_buffer[2] = slot;
	client_write(socket_fd, send_buffer, 3);

	i = client_read(socket_fd, recv_buffer, BUFFERLEN);
	recv_buffer[i] = 0;
	if(recv_buffer[0] == REFUSE)
	{
		not_superviser();
		return;
	}
	else 
	{
		printf("You killed %d user.\n", slot);
		return;
	}
}

void not_superviser(void)
{
	printf("# You are not superviser.\n");
	printf("# Cannot execute this command.\n");
}

void set_notice(void)
{
	printf("#SET NOTICE\n");
	send_buffer[0] = S_NOTICE;
	send_buffer[1] = myslot;

	strcpy(send_buffer+2, notice_msg);
	client_write(socket_fd, send_buffer, strlen(notice_msg)+3);
	printf("#Set -- %s\n", notice_msg);
}

void set_bulletin(void)
{
	printf("#REGIST To BULLETINE BOARD\n");
	send_buffer[0] = S_BULLTN;
	send_buffer[1] = myslot;

	strcpy(send_buffer+2, bulletin_msg);
	client_write(socket_fd, send_buffer, strlen(bulletin_msg)+3);
	printf("#Regist -- %s\n", bulletin_msg);
}

void look_notice(void)
{
	printf("#LOOK NOTICE\n");
	printf("# Now notice in VOICE .......\n");
	send_buffer[0] = L_NOTICE;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
	burst_read(socket_fd, recv_buffer, "");
}

void look_bulletin(void)
{
	printf("#LOOK BULLETIN BOARD\n");
	printf("# This VOICE server Bulletin Board is ......\n");
	send_buffer[0] = L_BULLTN;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
	burst_read(socket_fd, recv_buffer, "");
}

void version(void)
{
	int		i;
	printf("#VOICE VERSION\n");
	printf("# Request Voice version of server & client...\n");

	send_buffer[0] = SC_VER;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
	i = client_read(socket_fd, recv_buffer, BUFFERLEN);
	recv_buffer[i] = 0;

	printf("# VOICE Server %s\n", recv_buffer);
	printf("# VOICE Client %s\n", Client_ID);
}

void r_last(void)
{
	printf("#LAST\n");
	send_buffer[0] = R_LAST;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 3);
	burst_read(socket_fd, recv_buffer, "#");
}

void look_all(void)
{
	printf("#LOOK\n");
	send_buffer[0] = LISTEN;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
	burst_read(socket_fd, recv_buffer, "");
}

void look_room(int n_room)
{
	printf("#LOOK\n");
	send_buffer[0] = LOOK;
	send_buffer[1] = myslot;
	send_buffer[2] = (char)n_room;
	client_write(socket_fd, send_buffer, 3);
	burst_read(socket_fd, recv_buffer, "");
}

void change_handle(void)
{
#ifdef AUTO_KANJI
		trans_kanjicode(handle);
#endif

	send_buffer[0] = C_HANDLE;
	send_buffer[1] = myslot;
	strcpy(send_buffer+2, handle);
	client_write(socket_fd, send_buffer, strlen(handle)+3);
}

void silent_handle(void)
{
#ifdef AUTO_KANJI
		trans_kanjicode(handle);
#endif

	send_buffer[0] = S_HANDLE;
	send_buffer[1] = myslot;
	strcpy(send_buffer+2, handle);
	client_write(socket_fd, send_buffer, strlen(handle)+3);
}


void change_title(void)
{
	send_buffer[0] = TITLE;
	send_buffer[1] = myslot;
	strcpy(send_buffer+2, title);
	client_write(socket_fd, send_buffer, strlen(send_buffer+2)+3);
}

void perform(void)
{
	send_buffer[0] = PERFORM;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
	printf("# Server Performance \n");	
	burst_read(socket_fd, recv_buffer, "");
}

void color_control(int sw)
{
	if(sw == ON)	send_buffer[0] = COLOR_ON;
	if(sw == OFF)	send_buffer[0] = COLOR_OFF;
	color_flag = sw;
	send_buffer[1] = myslot;
	client_write(socket_fd, send_buffer, 2);
}

void color_set(void)
{
	send_buffer[0] = COLOR_SET;
	send_buffer[1] = myslot;
	send_buffer[2] = color_code;
	client_write(socket_fd, send_buffer, 3);
}
void echo_control(int sw)
{
	struct termios		termio_p;

	tcgetattr(0, &termio_p);
	switch(sw)
	{
		case ON:
			echo_flag = ON;
			termio_p.c_lflag = termio_back.c_lflag;
                        if (intr_ignore == ON) termio_p.c_lflag &= (ISIG ^ 0xffffffff);
			tcsetattr(0, 0, &termio_p);
			printf("# now, echo back on.\n");
			break;
		case OFF:
			echo_flag = OFF;
			termio_p.c_lflag &= (ECHO ^ 0xffffffff);
                        if (intr_ignore == ON) termio_p.c_lflag &= (ISIG ^ 0xffffffff);
			tcsetattr(0, 0, &termio_p);
			printf("# now, echo back off.\n");
			break;
	}
}

void intr_control(int sw)
{
        struct termios          termio_p;

        tcgetattr(0, &termio_p);
        switch(sw)
        {
                case ON:
                        termio_p.c_lflag = termio_int_back.c_lflag;
                        tcsetattr(0, 0, &termio_p);
                        break;
                case OFF:
                        termio_p.c_lflag &= (ISIG ^ 0xffffffff);
                        tcsetattr(0, 0, &termio_p);
                        break;
        }
}

void term_setup(void)
{
	struct termios		termio_p;

	tcgetattr(socket_fd, &termio_p);
	termio_p.c_iflag |= IXON;
	termio_p.c_iflag |= IXOFF;
	tcsetattr(socket_fd, 0, &termio_p);
	tcgetattr(0, &termio_p);
	termio_p.c_iflag |= IXON;
	termio_p.c_iflag |= IXOFF;
	tcsetattr(0, 0, &termio_p);



}	

void record(int sw)
{
	fclose(flog);
	log_flag = sw;
	if(sw == ON)  
		if((flog = fopen(record_dir, "a")) == NULL)
		{
			printf("# file open error. -- %s \n", record_dir);
			sw = OFF;
		}
		else
		{
			printf("# logging start. -- %s\n", record_dir);
		}
}


void command_menu(int op_code)
{
	int		res;
	int		echo_flag_back;

	switch(op_code)
	{
		case OP_ENTER_1:
		case OP_ENTER_2:
		case OP_ENTER_3:
		case OP_ENTER_4:
		case OP_ENTER_5:
		case OP_ENTER_6:
			if(command_ar(OFF) != REFUSE)
			{
				printf("already in the room!! \n");
				break;
			}
			res = enter_room(op_code);
			if(res == ENTER_OK) main_session();
			break;
		case OP_LOOK_A:
			look_all();
			break;
		case OP_LOOK_1:
			look_room(ROOM1);
			break;
		case OP_LOOK_2:
			look_room(ROOM2);
			break;
		case OP_LOOK_3:
			look_room(ROOM3);
			break;
		case OP_LOOK_4:
			look_room(ROOM4);
			break;
		case OP_LOOK_5:
			look_room(ROOM5);
			break;
		case OP_LOOK_6:
			look_room(ROOM6);
			break;
		case OP_LOOK_D:
			if(command_ar(OFF) == REFUSE)
				look_all();
			else look_room(flag);
			break;
		case OP_NLOOK:
			if(command_ar(OFF) == REFUSE)
			{
				look_all();
				look_notice();
			}
			else
			{
				look_room(flag);
				look_notice();
			}
			break;
		case OP_S_NOTICE:
			set_notice();
			break;
		case OP_L_NOTICE:
			look_notice();
			break;
		case OP_S_BULLETIN:
			set_bulletin();
			break;
		case OP_L_BULLETIN:
			look_bulletin();
			break;
		case OP_REC_ON:
			record(ON);
			break;
		case OP_REC_OFF:
			record(OFF);
			break;
		case OP_COLOR_ON:
			color_control(ON);
			break;
		case OP_COLOR_OFF:
			color_control(OFF);
			break;
		case OP_COLOR_SET:
			color_set();
			break;
		case OP_HANDLE:
			change_handle();
			break;
		case OP_TITLE:
			if(command_ar(ON) == REFUSE) break;
			change_title();
			break;
		case OP_ECHO_ON:
			if(command_ar(ON) == REFUSE) break;
			echo_control(ON);
			break;
		case OP_ECHO_OFF:
			if(command_ar(ON) == REFUSE) break;
			echo_control(OFF);
			break;		
		case OP_PERFORM:
			perform();
			break;
		case OP_DOOR_OPEN:
			if(command_ar(ON) == REFUSE) break;
			door(OPEN);
			break;
		case OP_DOOR_CLOSE:
			if(command_ar(ON) == REFUSE) break;
			door(CLOSE);
			break;
		case OP_DOOR_LOCK:
			if(command_ar(ON) == REFUSE) break;
			door(LOCK);
			break;
		case OP_RT:
			if(command_ar(ON) == REFUSE) break;
			echo_flag_back = (int)echo_flag;
			echo_control(ON);
			room_telegram();
			echo_control((int)echo_flag_back);
			break;
		case OP_SHELL:
			system("tcsh");
			echo_control((int)echo_flag);
			break;
		case OP_VER:
			version();
			break;
		case OP_LAST:
			r_last();
			break;
		case OP_RESET:
			reset_server();
			break;
		case OP_SUPER:
			change_mode(SUPERVISE);
			break;
		case OP_NORMAL:
			change_mode(NORMAL);
			break;
		case OP_SLOOK:
			super_look();
			break;
		case OP_SCLOSE:
			super_close();
			break;
		case OP_SEXIT:
			super_exit(SEXIT);
			break;
		case OP_SHUNG:
			super_exit(SHUNG);
			break;
		case OP_SKILL:
			super_kill();
			break;
		case OP_HELP:
			print_com_help();
			break;
		case OP_EXIT:
			logout();
			exit(1);
		case OP_ILLI:
			printf("Invalid Command!! \n");
			break;
	}
}

void menu_session(void)
{
	char	command[50];
	int		op_code;

	for(;;)
	{
		if(sp_flag == NORMAL) printf("VOICE>>");
		if(sp_flag == SUPERVISE) printf("VOICE!!>>");
		if(fgets(command, 50, stdin) != NULL)
		{
			cut_return(command);
			op_code = command_ana(command);
			command_menu(op_code);
		}
	}
}

#ifdef AUTO_KANJI
void trans_kanjicode(char *source)
{
	char	work[BUFFERLEN];

	switch(kanji_code)
	{
		case SJIS:
			to_sjis(work, source);
			break;
		case JIS:
			to_jis(work, source);
			break;
		case EUC:
			to_euc(work, source);
			break;
	}
	strcpy(source, work);
}
#endif

void main_session(void)
{
	u_char	d;
	char		messages[BUFFERLEN];
	char		work[BUFFERLEN];
	char		kpwork[5];
	int			c, i, j, op_code, found;
	int			len, mesg_len, cut_len = 0;
	fd_set	readok;

	len = 0;

	while(1)
	{
		readok = mask;
		found = select(width, (fd_set*)&readok, NULL, NULL, NULL);

		if((found > 0) && FD_ISSET(socket_fd, &readok))
		{
			int		n;
			n = client_read(socket_fd, recv_buffer, BUFFERLEN);
			recv_buffer[n] = 0;
			switch(recv_buffer[0])
			{
				case MESSAGE:
				case ALL_MSG:
				case ROOM_MSG:
				case TELEGRAM:
					shutdown_count = 0;
#ifdef AUTO_KANJI
					trans_kanjicode(recv_buffer+2);
#endif
					strcpy(messages, recv_buffer+2);
					printf("%s", messages);
					if(log_flag == ON) fprintf(flog, "%s", recv_buffer+2);
					break;
				case KEEP_ALIVE:
					kpwork[0] = KEEP_ALIVE;
					kpwork[1] = myslot;
					kpwork[2] = 0;
					client_write(socket_fd, kpwork, 3);
					keep_counter = 0;
					break;
				case EMERGENCY:
					printf("EMERGENCY CALL --- VOICE SERVER SYSTEM WAS HUNGUP!!\n");
					printf("Please call cerbe@yamato.cc.kogakuin.ac.jp.\n");
					printf("\a\aSorry, Server was Killed.\n");
					exit(1);
				case IGNORE_INTR:
					signal(SIGINT, SIG_IGN);
					break;
				case ACCEPT_INTR:
					signal(SIGINT, key_break);
					break;
				default:
					shutdown_count++;
					if(shutdown_count > SH_MAX)
					{
						printf("\a# Connexion error.\n");
						printf("# Sorry, Connextion closed....\n");
      						exit(1);
					}
						
					printf("Unknown packet or message from server -- %d.\n", recv_buffer[0]);
					break;
			}
		}



		if((found > 0) && FD_ISSET(0, &readok))
		{
			read(0, &d, 1);
			c = (int)d;
			send_buffer[2 + len++] = c;
			if(len > (BUFFERLEN-10)) len--;

			if(c == '\n')
			{
				send_buffer[2 + len] = 0;
				if(send_buffer[2] == '!')
				{
					cut_return(send_buffer+3);
					op_code = command_ana(send_buffer+3);
					switch(op_code)
					{
						case OP_EXIT:
							exit_room();
							return;
						default:
							command_menu(op_code);
							len = 0;
					}
				}
				else if(!strncmp(send_buffer+2, centering, 2) || !strncmp(send_buffer+2, "/", 1))
				{
					if(!strncmp(send_buffer+2, centering, 2)) cut_len = 2;
					if(!strncmp(send_buffer+2, "/", 1)) cut_len = 1;
					mesg_len = len;
					strcpy(work, " ");
					if(mesg_len < 78)
					{
						j = (WIDTH - mesg_len) / 2 - 2 - strlen(handle);
						for(i=0; i<j-(cut_len^3); i++, len++) strcat(work, " ");
						strcat(work, send_buffer + 2 + cut_len);
						strcpy(send_buffer+2, work);
					}
					send_buffer[0] = MESSAGE;	
					send_buffer[1] = myslot;
					send_buffer[2 + len++] = 0;
					client_write(socket_fd, send_buffer, len+2);
					len = 0;					
				}
				else if(!strncmp(send_buffer+2, flushleft, 2) || !strncmp(send_buffer+2, "*", 1))
				{
					if(!strncmp(send_buffer+2, flushleft, 2)) cut_len = 2;
					if(!strncmp(send_buffer+2, "*", 1)) cut_len = 1;
					mesg_len = len - 1;
					strcpy(work, " ");
					if(mesg_len < 78)
					{
						j = WIDTH - mesg_len - strlen(handle) - 3;
						for(i=0; i<j-(cut_len^3)+1; i++, len++) strcat(work, " ");
						strcat(work, send_buffer + 2 + cut_len);
						strcpy(send_buffer+2, work);
					}
					send_buffer[0] = MESSAGE;	
					send_buffer[1] = myslot;
					send_buffer[2 + len++] = 0;
					client_write(socket_fd, send_buffer, len+2);
					len = 0;					
				}
				else
				{
					send_buffer[0] = MESSAGE;	
					send_buffer[1] = myslot;
					send_buffer[2 + len++] = 0;
					client_write(socket_fd, send_buffer, len+2);
					len = 0;
				}
			}
		}

	}
}

int client_write(int cfd, char *data, int len)
{
	int		rt_code;

	rt_code = check_write(cfd, data, len);
	if(rt_code != -1) return rt_code;

	printf("\a# Connexion error.\n");
	printf("# Sorry, Connextion closed....\n");
	exit(1);
}

int client_read(int cfd, char *data, int len)
{
	int		rt;

	if((rt = tcp_read(cfd, data, len)) == TCP_ERROR)
	{
		printf("#\a Sorry, An inpediment in connextion.\n");
		printf("# Connextion closed......\n");
		exit(1);
	}
	return rt;
}

void print_com_help(void)
{
	if(flag > MAX_ROOM)
	{
		printf("#HELP\n");
		printf("# ?               : help\n");
		printf("# help            : help\n");
		printf("# enter [1~%d]     : enter the room\n", MAX_ROOM);
		printf("# look [1~%d]      : look room\n", MAX_ROOM);
		printf("# look all        : look all room\n");
		printf("# notice {msg}    : set & look notice\n");
		printf("# handle [HANDLE] : change handle\n");
		printf("# last {number}   : indicate last logouts by number\n");
		printf("# record [on|off] : chat log\n");
		printf("# color [on|off]  : colour on/off control\n");
		printf("# color [number]  : set colour\n");
		printf("# bulletin {msg}  : set & look bulletin board\n");
		printf("# kanji [CODE]    : set kanji code [SJIS|JIS|EUC]\n");
		printf("# sjis            : set SJIS kanji mode\n");
		printf("# jis             : set JIS kanji mode\n");
		printf("# euc             : set EUC kanji mode\n");
		printf("# ver             : check version\n");
		printf("# perf            : server performance\n");
		printf("# exit            : exit VOICE\n");
		printf("# quit            : exit VOICE\n");
		if(sp_flag != SUPERVISE) return;
		printf("# --- Now superviser!! ---\n");
		printf("# normaluser      : to normal user\n");
		printf("# slook           : super look\n");
		printf("# sexit           : super exit(save)\n");
		printf("# skill           : super kill\n");
		printf("# shung           : super hungup\n");
	}
	else
	{
		printf("#HELP\n");
		printf("# !?                      : help\n");
		printf("# !help                   : help\n");
		printf("# !look [1~%d]             : look room\n", MAX_ROOM);
		printf("# !look all               : look all room\n");
		printf("# !notice {msg}           : set & look notice\n");
		printf("# !handle [HANDLE]        : change handle\n");
		printf("# !title [TITLE]          : change room title\n");
		printf("# !last {number}          : indicate last logoutsby number\n");
		printf("# !record [on|off]        : chat log control\n");
		printf("# !color [on|off]         : colour on/off control\n");
		printf("# !color [number]         : set colour\n");
		printf("# !bulletin {msg}         : set & look bulletin board\n");
		printf("# !kanji [CODE]           : set kanji code [SJIS|JIS|EUC]\n");
		printf("# !sjis                   : set SJIS kanji mode\n");
		printf("# !jis                    : set JIS kanji mode\n");
		printf("# !euc                    : set EUC kanji mode\n");
		printf("# !ver                    : check version\n");
		printf("# !perf                   : server performance\n");
		printf("# !door [open|lock|close] : door control\n");
		printf("# !echo [on|off]          : echo back control\n");
		printf("# !!                      : telegram in room\n");
		printf("# !exit                   : exit room\n");
		printf("# !quit                   : exit room\n");
	}
}

void key_break(int SIGNO)
{
	if(flag <= MAX_ROOM)	
		exit_room();

	logout();
	exit(1);
}

void handle_setup(void)
{
	char *p;

	get_idname(idname);
	if((p = getenv("VOICE_HANDLE")) == NULL)
		sprintf(handle, "%s", idname);
	else strcpy(handle, p);
}
void print_help(void)
{
                fprintf(stderr, "   [Options] : -handle [handle]   : handle setup\n");
                fprintf(stderr, "               -backlog           : back log on\n");
                fprintf(stderr, "               -record            : recording on\n");
                fprintf(stderr, "               -color [colorcode] : color setup\n");
                fprintf(stderr, "               -nocolor           : no use colour\n");
		fprintf(stderr, "               -nointr            : ignore CTRL-C key\n");
		fprintf(stderr, "               -keepalive         : console keep alive\n");
		fprintf(stderr, "               -claddress         : notice remote host\n");
		fprintf(stderr, "               -help              : show this help\n");
		fprintf(stderr, "               -v                 : show now patchlevel\n");
#ifdef AUTO_KANJI
                fprintf(stderr, "               -sjis              : set SJIS mode(.def)\n");
                fprintf(stderr, "               -euc               : set EUC mode\n");
                fprintf(stderr, "               -jis               : set JIS mode\n");
#endif
}


int main(int argc, char **argv)
{
	char	host[20];
	int		flag;

	ack_num = 0;
	sprintf(Client_ID, CLIENT_ID, PATCHLEVEL);

	if(argc < 2) strcpy(host, DEFAULT_SERVER);
	handle_setup();
	init_path();

	flag = 0;
	intr_ignore = OFF;
	intr_connect = OFF;
	cl_address = OFF;
	while(--argc > 0)
	{
		argv++;
		     if(!strcmp(*argv, "-handle"))	{strcpy(handle, *++argv); argc--;}
		else if(!strcmp(*argv, "-backlog")) {backlog_flag = ON;}
		else if(!strcmp(*argv, "-record"))  {record(ON);}
		else if(!strcmp(*argv, "-nocolor"))	{color_flag = OFF;}
		else if(!strcmp(*argv, "-nocolour")){color_flag = OFF;}
		else if(!strcmp(*argv, "-nointr"))	{intr_ignore = ON;}
		else if(!strcmp(*argv, "-keepalive"))	{intr_connect = ON;}
		else if(!strcmp(*argv, "-claddress"))	{cl_address = ON;}
#ifdef AUTO_KANJI
		else if(!strcmp(*argv, "-sjis"))		{kanji_code = SJIS; silent_handle();}
		else if(!strcmp(*argv, "-euc"))			{kanji_code = EUC; silent_handle();}
		else if(!strcmp(*argv, "-jis"))			{kanji_code = JIS; silent_handle();}
#endif
		else if(!strcmp(*argv, "-color"))		{color_code = atoi(*++argv); argc--;}
		else if(!strcmp(*argv, "-help"))		{print_help(); exit(0);}
		else if(!strcmp(*argv, "-v"))			{printf("%s\n", Client_ID); exit(0);}
		else flag = 1;
	}	

	if(flag == 1)
	{
		if(*argv[0] == '-')
			fprintf(stderr, "# invalid option. ---------- \n");
		else strcpy(host, *argv);
	}
	else					strcpy(host, DEFAULT_SERVER);

	if(setup_client(host, PORT) < 0) exit(1);
	init_session();
	menu_session();
	term_setup();
	main_session();
  return(0);
}
