#define		PATCHLEVEL	12
#define		SERVER_ID	"Revision 1.1  Patchlevel %2.2d"
#define		CLIENT_ID	"Revision 1.1  Patchlevel %2.2d"
#define		REVISION	1

#define		PRIVATE		static
#define		PUBLIC

#define		SH_MAX		10
#define		MAX_USER	250
#define		MAX_ROOM	6
#define		LOG				10
#define		BUFFERLEN	512
#define		BULLTNLEN	76
#define		TIMESTR		60
#define		PORT			10027
#define		SOCKBUF		32768
#define		ON				1
#define		OFF				0
#define		SYSLOG		99
#define		LENGTH		100
#define		CTRL_D		96
#define		WAIT_TIME	20
#define		TERMINATE	-1
#define		TCP_ERROR	-2
#define		KP_INTER	60

#define		C_BLACK		0
#define		C_BLUE		1
#define		C_RED			2
#define		C_MAGENTA	3
#define		C_GREEN		4
#define		C_CYAN		5
#define		C_YELLOW	6
#define		C_WHITE		7
#define		C_INIT		8

#define		ROOM_LOG_ENABLE 1       /* 1:ON 0:OFF */
#define		ROOM_LOG_PATH   "/home/cerbe/html/voicelog"     /* no "/" delimiter */


#define		S_BLACK		"\033[30m"
#define		S_BLUE		"\033[34m"
#define		S_RED			"\033[31m"
#define		S_MAGENTA	"\033[35m"
#define		S_GREEN		"\033[32m"
#define		S_CYAN		"\033[36m"
#define		S_YELLOW	"\033[33m"
#define		S_WHITE		"\033[37m"
#define		S_INIT		"\033[0m"

#define		SJIS			0
#define		JIS				1
#define		EUC				2

#define		FREE			10					/* free slot           */
#define		IN_USE		11					/* used slot           */
#define		OPEN			12					/* opened room         */
#define		CLOSE			13					/* closeed room        */
#define		LOCK			14					/* locked room         */
#define		ROOM1			1						/* Room 1 entered      */
#define		ROOM2			2						/* Room 2 entered      */
#define		ROOM3			3						/* Room 3 entered      */
#define		ROOM4			4						/* Room 4 entered      */
#define		ROOM5			5						/* Room 5 entered      */
#define		ROOM6			6						/* Room 6 entered      */


/* To Server */
/* normal user mode */
#define		ENTER_1		ROOM1				/* room 1 enter packet */
#define		ENTER_2		ROOM2				/* room 2 enter packet */
#define		ENTER_3		ROOM3				/* room 3 enter packet */
#define		ENTER_4		ROOM4				/* room 4 enter packet */
#define		ENTER_5		ROOM5				/* room 5 enter packet */
#define		ENTER_6		ROOM6				/* room 6 enter packet */
#define		MESSAGE		10					/* message packet      */
#define		LOGIN			11					/* login packet        */
#define		LOGOUT		12					/* logout packet       */
#define		C_HANDLE	13					/* change handle       */
#define		LISTEN		14					/* listen the room     */
#define		LOOK			15					/* look room           */
#define		EXIT			16					/* exit room           */
#define		ALL_MSG		17					/* mesg to all users   */
#define		ROOM_MSG	18					/* mesg to room users  */
#define		TITLE			19					/* change room title   */
#define		DOOR			20					/* door status change  */
#define		ROOM_TELE	21					/* room telegram req   */
#define		TELEGRAM	22					/* receive telegram    */
#define		VERSION_C	23					/* version check       */
#define		L_NOTICE	24					/* look notice         */
#define		S_NOTICE	25					/* set notice          */
#define		R_LOG			26					/* request room log    */
#define		SC_VER		27					/* request version     */
#define		R_LAST		28					/* request last        */
#define		COLOR_ON	29					/* colour on           */
#define		COLOR_OFF	30					/* colour off          */
#define		COLOR_SET	31					/* set colour          */
#define		REQ_ALL		32					/* request all users   */
#define		S_HANDLE	33					/* silent handle chng  */
#define		PERFORM		34					/* performance         */
#define		S_BULLTN	35					/* set bulletin board  */
#define		L_BULLTN	36					/* look bulletin board */
#define		CL_ADDRESS	37					/* client address */
/* superviser mode */
#define		SLOOK			50					/* super look          */
#define		SEXIT			51					/* super exit          */
#define		SKILL			52					/* super kill          */
#define		SHUNG			53					/* super hung up       */
#define		SCLOSE		54					/* super close         */
/* system code */
#define		ACK				92					/* Acknowledge         */
#define		NACK			93					/* Nacknowledge        */
#define		NORMAL		94					/* change normal       */
#define		SUPERVISE	95					/* change superviser   */
#define		RESET			96					/* server reset        */
#define		EMERGENCY	97					/* server emergency    */
#define		ENDOFDATA	98					/* end of data         */
#define		NOP				99					/* no operation        */

/* From Server */
#define		CANNOT_LOGIN	101			/* cannot login        */
#define		LOGIN_OK			102			/* login ok            */
#define		CANNOT_ENTER	103			/* cannot enter room   */
#define		ENTER_OK			104			/* enter room ok       */
#define		ACCEPT				105			/* command accept      */
#define		REFUSE				106			/* command refuse      */
#define		IGNORE_INTR		107			/* ignore interrupt    */
#define		ACCEPT_INTR		108			/* accept interrupt    */
#define		KEEP_ALIVE		91			/* keep alive packet   */
/* command */
#define		OP_ILLI				99			/* error               */
#define		OP_EXIT				98			/* exit voice          */
#define		OP_HELP				97			/* help                */
#define		OP_ENTER_1		ROOM1		/* enter room 1        */
#define		OP_ENTER_2		ROOM2		/* enter room 2        */
#define		OP_ENTER_3		ROOM3		/* enter room 3        */
#define		OP_ENTER_4		ROOM4		/* enter room 4        */
#define		OP_ENTER_5		ROOM5		/* enter room 5        */
#define		OP_ENTER_6		ROOM6		/* enter room 6        */
#define		OP_LOOK_A			10			/* look all            */
#define		OP_LOOK_1			11			/* look room 1         */
#define		OP_LOOK_2			12			/* look room 2         */
#define		OP_LOOK_3			13			/* look room 3         */
#define		OP_LOOK_4			14			/* look room 4         */
#define		OP_LOOK_5			15			/* look room 5         */
#define		OP_LOOK_6			16			/* look room 6         */
#define		OP_LOOK_D			20			/* look default        */
#define		OP_REC_ON			21			/* record on           */
#define		OP_REC_OFF		22			/* record off          */
#define		OP_SHELL			23			/* shell               */
#define		OP_HANDLE			24			/* change handle       */
#define		OP_TITLE			25			/* change title        */
#define		OP_RESET			26			/* server reset        */
#define		OP_DOOR_OPEN	27			/* open door           */
#define		OP_DOOR_CLOSE	28			/* close door          */
#define		OP_DOOR_LOCK	29			/* lock door           */
#define		OP_RT					30			/* room tele           */
#define		OP_S_NOTICE		31			/* set notice          */
#define		OP_L_NOTICE		32			/* look notice         */
#define		OP_ECHO_ON		33			/* echo on             */
#define		OP_ECHO_OFF		34			/* echo off            */
#define		OP_NLOOK			35			/* look & notice       */
#define		OP_VER				36			/* request version     */
#define		OP_LAST				37			/* request last        */
#define		OP_COLOR_ON		38			/* colour on           */
#define		OP_COLOR_OFF	39			/* colour off          */
#define		OP_COLOR_SET	40			/* set colour          */
#define		OP_SUPER			50			/* request superviser  */
#define		OP_NORMAL			51			/* request normaluser  */
#define		OP_SLOOK			52			/* super look          */
#define		OP_SEXIT			53			/* super kill          */
#define		OP_SKILL			54			/* super exit          */
#define		OP_SHUNG			55			/* super hung up       */
#define		OP_KANJI			56			/* kanji code change   */
#define		OP_SHANDLE		57			/* silent handle       */
#define		OP_SCLOSE			58			/* super close         */
#define		OP_PERFORM		59			/* performance         */
#define		OP_L_BULLETIN	60			/* look bulletin board */
#define		OP_S_BULLETIN	61			/* set bulletin board  */

typedef struct
{
  char  mesg[BUFFERLEN*2];
} MESG_BACK;
   
typedef struct
{
	int		flag;										/* login flag          */
	int		sp_flag;								/* superviser flag     */
	int		fd;											/* file descripter     */
	int		idle_time;							/* idling time         */
	int		kp_count;								/* kp count            */
	int		kp_idle;								/* kp idle time        */
	int		color_code;							/* colour code         */
	int		req_idle_flag;					/* REQ idle flag       */
	char	username[LENGTH*2];			/* user name           */
	char	notice[LENGTH*2];				/* notice msg          */
	char	id[LENGTH*2];									/* user ID             */
	u_char	address[4];						/* data gram address   */
	u_char	color_flag;						/* colour flag         */
	u_char	cl_address[LENGTH*2];			/*getutline host */
} USER_SYSTEM;

typedef struct
{
	int		status;									/* room status         */
	int		door;										/* door status         */
	int		n_menber;								/* number of menber    */
	char	room_title[LENGTH*2];		/* room title          */
	int		log_number;							/* room log number     */
	MESG_BACK	rmlog[LOG];					/* room log            */
}	ROOM_SYSTEM;


typedef struct
{
	int		num;
	int		idle;
	int		flag;
	char	username[LENGTH*2];
	char	id[LENGTH*2];
	char	stime[LENGTH*2];
	char	message[LENGTH*2];
} BULLETIN_B;

