#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<pwd.h>
#include	<termios.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<netinet/in.h>

#include	<time.h>
#include	<netdb.h>
#include	<signal.h>
#include	<ctype.h>
#include	"voice.h"

PUBLIC	char*	seperate_par(char*);
PUBLIC	char*	strlower(char*);
PUBLIC	void	cut_return(char*);
PUBLIC	void	get_idname(char*);
PUBLIC	void	noecho_scanf(char*, char*);
PUBLIC	void	lbcopy(char*, char*, int);
PUBLIC	void	lbzero(char*, int);
PUBLIC	int  	file_seek(FILE*, long);
PUBLIC	void	etos(u_char*);
PUBLIC	u_char*	stoe(u_char*);
PUBLIC	void	kconv(u_int, u_int, u_char*);
PUBLIC	void	kconv1(u_int, u_int, u_char*);

char* seperate_par(char *string)
{
	int		i;
	int		len = strlen(string);

	for(i=0; i<len; i++, string++)
		if(*string == ' ')
		{
			*string = 0;
			return	(string+1);
		}
	return	(NULL);
}

char* strlower(char *string)
{
	int		c;
	char	*convstr;

	convstr = string;
	while((c = *string) != 0)
		*string++ = (char)tolower(c);
	return convstr;
}

void cut_return(char *mesg)
{
	char    *p;

	if((p = strchr(mesg, '\n')) != NULL)
		*p++ = '\0';
}

void get_idname(char *id_name)
{
	struct passwd *pass;
	pass = getpwuid(getuid());
	strcpy(id_name, pass->pw_name);
}

void noecho_scanf(char *format, char *buffer)
{
	struct termios	termio_s;
	tcflag_t				back_lflag;
	tcgetattr(0, &termio_s);
	back_lflag = termio_s.c_lflag;
	termio_s.c_lflag = 0;
	tcsetattr(0, 0, &termio_s);

	scanf(format, buffer);

	termio_s.c_lflag = back_lflag;
	tcsetattr(0, 0, &termio_s);
}

int file_seek(FILE *fin, long pos)
{
	int		c;
	int		res = 0;

	while((c = fgetc(fin)) != '\n')
		res = fseek(fin, pos--, SEEK_END);
	if(res == 0) return pos;
	return -1;
}

void lbcopy(char *b1, char *b2, int len)
{
	int		i;

	for(i=0;*b1!=0 && i<len;*(b2++)=*(b1++),i++);
}

void lbzero(char *b, int len)
{
	int		i;
	
	for(i=0;*b!=0 && i<len;*(b++)=0,i++);
}


void etos(u_char *buf)
{
	u_char s[BUFFERLEN];
	u_char *p;
	u_char *p1;
	u_int c;
	u_int c1;

	p = buf;
	p1 = s;
	while((c = *p++))
	{
		if ((c >= 0xa1) && (c <= 0xfe))
		{
			/* Kanji */
			if (*p == 0) break;
			c1 = *p++;
			kconv(c, c1, p1);
			p1 += 2;
		}
		else if (c == 0x8e) *p1++ = *p++;
		else *p1++ = c;
	}
	*p1 = 0;
	strcpy(buf,s);
}

void kconv(u_int c1, u_int c2, u_char *ptr)
{
	c1 &= 0x7f;
	c2 &= 0x7f;
	if (c1 >= 0x5f) c1 += 0x80;
	if ((c1 % 2) == 0)
	{
		*ptr++ = ((c1 - 0x30)/2 + 0x88) & 0xff;
		*ptr = (c2 + 0x7e) & 0xff;
	}
	else
	{
		if (c2 >= 0x60) c2 += 1;
		*ptr++ = ((c1 - 0x31)/2 + 0x89) & 0xff;
		*ptr = (c2 + 0x1f) & 0xff;
	}
}

u_char *stoe(u_char *buf)
{
	static u_char s[BUFFERLEN];
	u_char *p;
	u_char *p1;
	u_int c;
	u_int c1;

	p = buf;
	p1 = s;
	while((c = *p++))
	{
		if ((c >= 0x81 && c <= 0x9f) || (c >= 0xe0 && c <= 0xfc))
		{
			/* Kanji */
			if (*p == 0) break;
			c1 = *p++;
			kconv1(c, c1, p1);
			p1 += 2;
		}
		else if (c >= 0xa1 && c <= 0xdf)
		{
			*p1++ = 0x8e;
			*p1++ = c;
		}
		else *p1++ = c;
	}
	*p1 = 0;
	return(s);
}

void kconv1(u_int c1,u_int c2,u_char *ptr)
{
	if (c1 >= 0xe0) c1 -= 0x40;
	if (c2 >= 0x9f)
	{
		*ptr++ = (c1 - 0x88)*2 + 0xb0;
		*ptr = c2 + 0x02;
	}
	else
	{
		if (c2 >= 0x7f)	c2 -= 1;
		*ptr++ = (c1 - 0x89)*2 + 0xb1;
		*ptr = c2 + 0x61;
	}
}

