#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/socket.h>
#include	"voice.h"
#include	"voice_tcp.h"
#include	"voice.conf"

extern	int	width;
extern	int	socket_fd;

PUBLIC	int		tcp_read(int, char*, int);
PUBLIC	int		check_write(int, char*, int);
PUBLIC	void	burst_read(int, char*, char*);
PUBLIC	void	flush_fd(int);

void burst_read(int bfd, char *readbuffer, char *prefix)
{
	int		i;

	for(;;)
	{
		for(i=0; i<BUFFERLEN; i++) readbuffer[i]=0;
		i = tcp_read(bfd, readbuffer, BUFFERLEN);
		if(readbuffer[0] == ENDOFDATA) return;
		printf("%s%s", prefix, readbuffer+1);

	}
}

int tcp_read(int rfd, char *data, int maxlen)
{
	int		n = 0, rc, found;
	int		retry;
	signed char	c;
	fd_set		read_block;

	for(retry=0; retry<TCP_RETRY; retry++)
	{
		FD_ZERO(&read_block);
		FD_SET(rfd, &read_block);
		found = select(rfd+1, (fd_set*)&read_block, NULL, NULL, NULL);

		if(FD_ISSET(rfd, &read_block) && (found >= 0))
		{
			for(n=0; n<maxlen+1; n++)
			{
				if((rc=read(rfd, (char*)&c, 1)) == 1)
				{
					*data = c;
					data++;
					if(c == TERMINATE) break;
				}
				else if(rc == 0)
				{
					if(n == 1) return 1;
					else			 break;
				}
				else
				{
					return -2;
				}
			}
			retry = TCP_RETRY + 1;
			break;
		}
	}

	if(retry > TCP_RETRY) return -1;

	*data = 0;
	return n;
}


int check_write(int cfd, char *data, int len)
{
	fd_set	writeok;
	struct timeval		timeout;
	int			found;
	int			write_len;

	timeout.tv_sec = 0;
	timeout.tv_usec = WAIT_TIME;
	data[len] = TERMINATE;

	FD_ZERO(&writeok);
	FD_SET(cfd, &writeok);
	found = select(width, NULL, (fd_set*)&writeok, NULL, &timeout);
	if(FD_ISSET(cfd, &writeok) && (found >= 0))
		write_len = write(cfd, data, len+1);
	else
		return (-1);

	return write_len;
}

void flush_fd(int fd)
{
        signed char             c;
        int             rc;

        while((rc = read(fd, (char*)&c, 1)) == 1);
}

